Package: changeforest
Type: Package
Title: Classifier Based Non-Parametric Change Point Detection
Version: 0.3.0
Author: Malte Londschien
Maintainer: Malte Londschien <malte@londschien.ch>
Description: Perform classifier based multivariate, non-parametric change point detection.
License: BSD_3_clause + file LICENSE
URL: https://github.com/mlondschien/changeforest
BugReports: https://github.com/mlondschien/changeforest
SystemRequirements: Cargo (>= 1.42.0) for installation from source.
Encoding: UTF-8
RoxygenNote: 7.1.2
Imports:
    R6
Suggests:
    testthat (>= 3.0.0)
Language: en-US
Config/testthat/edition: 3

# Random Forests for Change Point Detection

Change point detection aims to identify structural breaks in the probability
distribution of a time series. Existing methods either assume a parametric model for
within-segment distributions or are based on ranks or distances and thus fail in
scenarios with a reasonably large dimensionality.

`changeforest` implements a classifier-based algorithm that consistently estimates
change points without any parametric assumptions, even in high-dimensional scenarios.
It uses the out-of-bag probability predictions of a random forest to construct a
pseudo-log-likelihood that gets optimized using a computationally feasible two-step
method.

See [1] for details.

## Installation

To install from `conda-forge` (recommended), run
```bash
conda install -c conda-forge changeforest
```

To install from `PyPI`, run
```bash
pip install changeforest
```

## Example

In the following example, we perform random forest-based change point detection on
a simulated dataset with `n=600` observations and covariance shifts at `t=200, 400`.

```python
In [1]: import numpy as np
   ...: 
   ...: Sigma = np.full((5, 5), 0.7)
   ...: np.fill_diagonal(Sigma, 1)
   ...: 
   ...: rng = np.random.default_rng(12)
   ...: X = np.concatenate(
   ...:     (
   ...:         rng.normal(0, 1, (200, 5)),
   ...:         rng.multivariate_normal(np.zeros(5), Sigma, 200),
   ...:         rng.normal(0, 1, (200, 5)),
   ...:     ),
   ...:     axis=0,
   ...: )
```

The simulated dataset `X` coincides with the _change in covariance_ (CIC) setup
described in [1]. Observations in the first and last segment are independently drawn
from a standard multivariate Gaussian distribution. Observations in the second segment
are i.i.d. normal with mean zero and unit variance, but with a covariance of ρ = 0.7
between coordinates. This is a challenging scenario.

```python
In [2]: from changeforest import changeforest
   ...: 
   ...: result = changeforest(X, "random_forest", "bs")
   ...: result
Out[2]: 
                    best_split max_gain p_value
(0, 600]                   412   19.603   0.005
 ¦--(0, 412]               201   62.981   0.005
 ¦   ¦--(0, 201]           194  -12.951    0.76
 ¦   °--(201, 412]         211   -9.211   0.545
 °--(412, 600]             418  -37.519   0.915

In [3]: result.split_points()
Out[3]: [201, 412]
```

`changeforest` correctly identifies the change point around `t=200` but is slightly
off at `t=412`. The `changeforest` function returns a `BinarySegmentationResult`.
We use its `plot` method to investigate the gain curves maximized by the change point estimates:

```
In [4]: result.plot().show()
```
<p align="center">
  <img src="../docs/py_cic_rf_binary_segmentation_result_plot.png" />
</p>
Change point estimates are marked in red.

For `method="random_forest"` and `method="knn"`, the `changeforest` algorithm uses a two-step approach to
find an optimizer of the gain. This fits a classifier for three split candidates
at the segment's 1/4, 1/2 and 3/4 quantiles, computes approximate gain curves using
the resulting pseudo-log-likelihoods and selects the overall optimizer as a second guess.
We can investigate the gain curves from the optimizer using the `plot` method of `OptimizerResult`.
The initial guesses are marked in blue.

```
In [5]: result.optimizer_result.plot().show()
```
<p align="center">
  <img src="../docs/py_cic_rf_optimizer_result_plot.png" />
</p>
 
One can observe that the approximate gain curves are piecewise linear, with maxima
around the true underlying change points.

The `BinarySegmentationResult` returned by `changeforest` is a tree-like object with attributes
`start`, `stop`, `best_split`, `max_gain`, `p_value`, `is_significant`, `optimizer_result`, `model_selection_result`, `left`, `right` and `segments`. 
These can be interesting to investigate the output of the algorithm further.

The `changeforest` algorithm can be tuned with hyperparameters. See
[here](https://github.com/mlondschien/changeforest/blob/287ac0f10728518d6a00bf698a4d5834ae98715d/src/control.rs#L3-L30)
for their descriptions and default values. In Python, the parameters can
be specified with the [`Control` class](https://github.com/mlondschien/changeforest/blob/b33533fe0ddf64c1ea60d0d2203e55b117811667/changeforest-py/changeforest/control.py#L1-L26),
which can be passed to `changeforest`. The following will build random forests with
20 trees:

```python
In [6]: from changeforest import Control
   ...: changeforest(X, "random_forest", "bs", Control(random_forest_n_estimators=20))
Out[6]: 
                            best_split max_gain p_value
(0, 600]                           592  -11.786    0.01
 ¦--(0, 592]                       121    -6.26   0.015
 ¦   ¦--(0, 121]                    13  -14.219   0.615
 ¦   °--(121, 592]                 416   21.272   0.005
 ¦       ¦--(121, 416]             201   37.157   0.005
 ¦       ¦   ¦--(121, 201]         192   -17.54    0.65
 ¦       ¦   °--(201, 416]         207   -6.701    0.74
 ¦       °--(416, 592]             584  -44.054   0.935
 °--(592, 600]     
```

The `changeforest` algorithm still detects change points around `t=200, 400` but also
returns two false positives.

Due to the nature of the change, `method="change_in_mean"` is unable to detect any
change points at all:
```python
In [7]: changeforest(X, "change_in_mean", "bs")
Out[7]: 
          best_split max_gain p_value
(0, 600]         589    8.318 
```

## References

[1] M. Londschien, S. Kovács and P. Bühlmann (2022), "Random Forests for Change Point Detection", working paper.

# Random Forests for Change Point Detection

Change point detection aims to identify structural breaks in the probability
distribution of a time series. Existing methods either assume a parametric model for
within-segment distributions or are based on ranks or distances and thus fail in
scenarios with a reasonably large dimensionality.

`changeforest` implements a classifier-based algorithm that consistently estimates
change points without any parametric assumptions, even in high-dimensional scenarios.
It uses the out-of-bag probability predictions of a random forest to construct a
pseudo-log-likelihood that gets optimized using a computationally feasible two-step
method.

See [1] for details.

`changeforest` is available as rust crate, a Python package (on
[`PyPI`](https://pypi.org/project/changeforest/) and
[`conda-forge`](https://anaconda.org/conda-forge/changeforest)),
and an R package (on [`conda-forge`](https://anaconda.org/conda-forge/r-changeforest)
, linux and MacOS only). See below for their respective user guides.

## Python

### Installation

To install from `conda-forge` (recommended), run
```bash
conda install -c conda-forge changeforest
```

To install from `PyPI`, run
```bash
pip install changeforest
```

### Example

In the following example, we perform random forest-based change point detection on
a simulated dataset with `n=600` observations and covariance shifts at `t=200, 400`.

```python
In [1]: import numpy as np
   ...: 
   ...: Sigma = np.full((5, 5), 0.7)
   ...: np.fill_diagonal(Sigma, 1)
   ...: 
   ...: rng = np.random.default_rng(12)
   ...: X = np.concatenate(
   ...:     (
   ...:         rng.normal(0, 1, (200, 5)),
   ...:         rng.multivariate_normal(np.zeros(5), Sigma, 200),
   ...:         rng.normal(0, 1, (200, 5)),
   ...:     ),
   ...:     axis=0,
   ...: )
```

The simulated dataset `X` coincides with the _change in covariance_ (CIC) setup
described in [1]. Observations in the first and last segment are independently drawn
from a standard multivariate Gaussian distribution. Observations in the second segment
are i.i.d. normal with mean zero and unit variance, but with a covariance of ρ = 0.7
between coordinates. This is a challenging scenario.

```python
In [2]: from changeforest import changeforest
   ...: 
   ...: result = changeforest(X, "random_forest", "bs")
   ...: result
Out[2]: 
                    best_split max_gain p_value
(0, 600]                   412   19.603   0.005
 ¦--(0, 412]               201   62.981   0.005
 ¦   ¦--(0, 201]           194  -12.951    0.76
 ¦   °--(201, 412]         211   -9.211   0.545
 °--(412, 600]             418  -37.519   0.915

In [3]: result.split_points()
Out[3]: [201, 412]
```

`changeforest` correctly identifies the change point around `t=200` but is slightly
off at `t=412`. The `changeforest` function returns a `BinarySegmentationResult`.
We use its `plot` method to investigate the gain curves maximized by the change point estimates:

```
In [4]: result.plot().show()
```
<p align="center">
  <img src="docs/py_cic_rf_binary_segmentation_result_plot.png" />
</p>
Change point estimates are marked in red.

For `method="random_forest"` and `method="knn"`, the `changeforest` algorithm uses a two-step approach to
find an optimizer of the gain. This fits a classifier for three split candidates
at the segment's 1/4, 1/2 and 3/4 quantiles, computes approximate gain curves using
the resulting pseudo-log-likelihoods and selects the overall optimizer as a second guess.
We can investigate the gain curves from the optimizer using the `plot` method of `OptimizerResult`.
The initial guesses are marked in blue.

```
In [5]: result.optimizer_result.plot().show()
```
<p align="center">
  <img src="docs/py_cic_rf_optimizer_result_plot.png" />
</p>
 
One can observe that the approximate gain curves are piecewise linear, with maxima
around the true underlying change points.

The `BinarySegmentationResult` returned by `changeforest` is a tree-like object with attributes
`start`, `stop`, `best_split`, `max_gain`, `p_value`, `is_significant`, `optimizer_result`, `model_selection_result`, `left`, `right` and `segments`. 
These can be interesting to investigate the output of the algorithm further.

The `changeforest` algorithm can be tuned with hyperparameters. See
[here](https://github.com/mlondschien/changeforest/blob/287ac0f10728518d6a00bf698a4d5834ae98715d/src/control.rs#L3-L30)
for their descriptions and default values. In Python, the parameters can
be specified with the [`Control` class](https://github.com/mlondschien/changeforest/blob/b33533fe0ddf64c1ea60d0d2203e55b117811667/changeforest-py/changeforest/control.py#L1-L26),
which can be passed to `changeforest`. The following will build random forests with
20 trees:

```python
In [6]: from changeforest import Control
   ...: changeforest(X, "random_forest", "bs", Control(random_forest_n_estimators=20))
Out[6]: 
                            best_split max_gain p_value
(0, 600]                           592  -11.786    0.01
 ¦--(0, 592]                       121    -6.26   0.015
 ¦   ¦--(0, 121]                    13  -14.219   0.615
 ¦   °--(121, 592]                 416   21.272   0.005
 ¦       ¦--(121, 416]             201   37.157   0.005
 ¦       ¦   ¦--(121, 201]         192   -17.54    0.65
 ¦       ¦   °--(201, 416]         207   -6.701    0.74
 ¦       °--(416, 592]             584  -44.054   0.935
 °--(592, 600]     
```

The `changeforest` algorithm still detects change points around `t=200, 400` but also
returns two false positives.

Due to the nature of the change, `method="change_in_mean"` is unable to detect any
change points at all:
```python
In [7]: changeforest(X, "change_in_mean", "bs")
Out[7]: 
          best_split max_gain p_value
(0, 600]         589    8.318 
```

## R

To install from `conda-forge`, run

```bash
conda install -c conda-forge r-changeforest
```

See [here](https://github.com/conda-forge/miniforge) for instructions on how to install `conda`.

### Example

In the following example, we perform random forest-based change point detection on
a simulated dataset with `n=600` observations and covariance shifts at `t=200, 400`.

```R
> library(MASS)

> set.seed(0)
> Sigma = matrix(0.7, nrow=5, ncol=5)
> diag(Sigma) = 1
> mu = rep(0, 5)
> X = rbind(
    mvrnorm(n=200, mu=mu, Sigma=diag(5)),
    mvrnorm(n=200, mu=mu, Sigma=Sigma),
    mvrnorm(n=200, mu=mu, Sigma=diag(5))
)
```

The simulated dataset `X` coincides with the _change in covariance_ (CIC) setup
described in [1]. Observations in the first and last segment are independently drawn
from a standard multivariate Gaussian distribution. Observations in the second segment
are i.i.d. normal with mean zero and unit variance, but with a covariance of ρ = 0.7
between coordinates. This is a challenging scenario.


```R
> library(changeforest)

> result = changeforest(X, "random_forest", "bs")
> result
                 name best_split  max_gain p_value is_significant
1 (0, 600]                   410  13.49775   0.005           TRUE
2  ¦--(0, 410]               199  61.47201   0.005           TRUE
3  ¦    ¦--(0, 199]          192 -22.47364   0.955          FALSE
4  ¦    °--(199, 410]        396  11.50559   0.190          FALSE
5  °--(410, 600]             416 -23.52932   0.965          FALSE

> result$split_points()
[1] 199 410
```

`changeforest` correctly identifies the change point around `t=200` but is slightly
off at `t=410`. The `changeforest` function returns an object of class `binary_segmentation_result`.
We use its `plot` method to investigate the gain curves maximized by the change point estimates:

```
> plot(result)
```
<p align="center">
  <img src="docs/r_cic_rf_binary_segmentation_result_plot.png" />
</p>

Change point estimates are marked in red.

For `method="random_forest"` and `method="knn"`, the `changeforest` algorithm uses a two-step approach to
find an optimizer of the gain. This fits a classifier for three split candidates
at the segment's 1/4, 1/2 and 3/4 quantiles  computes approximate gain curves using
the resulting pseudo-log-likelihoods and selects the overall optimizer as a second guess.
We can investigate the gain curves from the optimizer using the `plot` method of `optimizer_result`.
The initial guesses are marked in blue.

```
> plot(result$optimizer_result)
```
<p align="center">
  <img src="docs/r_cic_rf_optimizer_result_plot.png" />
</p>
 
One can observe that the approximate gain curves are piecewise linear, with maxima
around the true underlying change points.

The `binary_segmentation_result` object returned by `changeforest` is a tree-like object with attributes
`start`, `stop`, `best_split`, `max_gain`, `p_value`, `is_significant`, `optimizer_result`, `model_selection_result`, `left`, `right` and `segments`. 
These can be interesting to investigate the output of the algorithm further.

The `changeforest` algorithm can be tuned with hyperparameters. See
[here](https://github.com/mlondschien/changeforest/blob/287ac0f10728518d6a00bf698a4d5834ae98715d/src/control.rs#L3-L30)
for their descriptions and default values. In R, the parameters can
be specified with the `Control` class,
which can be passed to `changeforest`. The following will build random forests with
20 trees:

```R
> changeforest(X, "random_forest", "bs", Control$new(random_forest_n_estimators=20))
                         name best_split   max_gain p_value is_significant
1 (0, 600]                            15  -6.592136   0.010           TRUE
2  ¦--(0, 15]                          6 -18.186534   0.935          FALSE
3  °--(15, 600]                      561  -4.282799   0.005           TRUE
4      ¦--(15, 561]                  116  -8.084126   0.005           TRUE
5      ¦    ¦--(15, 116]              21 -17.780523   0.130          FALSE
6      ¦    °--(116, 561]            401  11.782002   0.005           TRUE
7      ¦        ¦--(116, 401]        196  22.792401   0.150          FALSE
8      ¦        °--(401, 561]        554 -16.338703   0.800          FALSE
9      °--(561, 600]                 568  -5.230075   0.120          FALSE    
```

The `changeforest` algorithm still detects the change point around `t=200` but also
returns false positives.

Due to the nature of the change, `method="change_in_mean"` is unable to detect any
change points at all:
```R
> changeforest(X, "change_in_mean", "bs")
      name best_split max_gain p_value is_significant
1 (0, 600]        498 17.29389      NA          FALSE
```


## References

[1] M. Londschien, S. Kovács and P. Bühlmann (2022), "Random Forests for Change Point Detection", working paper.

# Classifier based non-parametric change point detection

Change point detection tries to identify times when the probability distribution of a
stochastic process or time series changes. Existing methods either assume a parametric
model for within-segment distributions or a based on ranks or distances, and thus fail
in scenarios with reasonably large dimensionality.

`changeforest` implements a classifier based algorithm that consistently estimates
change points without any parametric assumptions even in high-dimensional scenarios.
See [1] for details.

## Installation

To install from `conda-forge` (currently linux and MacOs only), simply run
```bash
conda install -c conda-forge r-changeforest
```
Note that `r-changeforest` is currently available for linux and MacOs only.

## Example

The following example performs random forest based change point detection on the iris
dataset. This includes three classes _setosa_, _versicolor_ and _virginica_ with 50
observations each. We interpret this as a simulated time series with change points at
`t = 50, 100`.

```R
> library(changeforest)
> library(datasets)
> data(iris)
> X <- as.matrix(iris[, 1:4])
> changeforest(X, "random_forest", "bs")
                name best_split  max_gain p_value is_significant
1 (0, 150]                   50 96.173664    0.01           TRUE
2  ¦--(0, 50]                34 -5.262184    1.00          FALSE
3  °--(50, 150]             100 51.557473    0.01           TRUE
4      ¦--(50, 100]          80 -3.068934    1.00          FALSE
5      °--(100, 150]        134 -2.063508    1.00          FALSE
```

`changeforest` also implements methods `change_in_mean` and `knn`. While `random_forest`
and `knn` implement the `TwoStepSearch` optimizer as described in [1], for
`change_in_mean` the optimizer `GridSearch` is used. Both `random_forest` and `knn`
perform model selection via a pseudo-permutation test (see [1]). For `change_in_mean`
split candidates are kept whenever `max_gain > control.minimal_gain_to_split`.

The iris dataset allows for rather simple classification due to large mean shifts between classes. As a
result, both `change_in_mean` and `knn` also correctly identify die true change points.

```R
> result <- changeforest(X, "change_in_mean", "bs")
> result$split_points()
[1] [50, 100]
> result <- changeforest(X, "knn", "bs")
> result$split_points()
[1] [50, 100]
```

`changeforest` returns a tree-like object with attributes `start`, `stop`, `best_split`, `max_gain`, `p_value`, `is_significant`, `optimizer_result`, `model_selection_result`, `left`, `right` and `segments`. These can be interesting to further investigate the output of the algorithm. Here we
plot the approximated gain curves of the first three segments:
```R
> library(ggplot2)
> result <- changeforest(X, "random_forest", "bs")
> data = data.frame(
        t=1:150,
        gain=result$optimizer_result$gain_results[[3]]$gain,
        gain_left=c(result$left$optimizer_result$gain_results[[3]]$gain, rep(NA, 100)),
        gain_right=c(rep(NA, 50), result$right$optimizer_result$gain_results[[3]]$gain)
)

> ggplot(data=data) +
        geom_line(aes(x=t, y=gain), color="blue") + 
        geom_line(aes(x=t, y=gain_left), color="orange") + 
        geom_line(aes(x=t, y=gain_right), color="green")
```

<p align="center">
  <img src="../docs/r-iris-approx-gains.png" />
</p>

One can clearly observe that the approx. gain curves are piecewise linear, with maxima
at the true underlying change points.

The `changeforest` algorithm can be tuned with hyperparameters. See [here](https://github.com/mlondschien/changeforest/blob/b33533fe0ddf64c1ea60d0d2203e55b117811667/src/control.rs#L3-L39) for their descriptions and default values. In R, the parameters can
be specified with the [`Control` class](https://github.com/mlondschien/changeforest/blob/main/changeforest-r/R/control.R)
 which can be passed to `changeforest`. The following
will build random forests with very few trees:

```R
> changeforest(X, "random_forest", "bs", Control(random_forest_ntrees=10))
... TODO
```

## References

[1] M. Londschien, S. Kovács and P. Bühlmann (2021), "Random Forests and other nonparametric classifiers for multivariate change point detection", working paper.

#' Storage container for hyperparameters.
#'
#' See rust documentation of changeforest::control::Control for more details.
#' @export
Control = R6::R6Class(
    "control",
    list(
        minimal_relative_segment_length = NULL,
        minimal_gain_to_split = NULL,
        model_selection_alpha = NULL,
        number_of_wild_segments = NULL,
        seeded_segments_alpha = NULL,
        seed = NULL,
        random_forest_ntrees = NULL,       

        initialize = function(
            minimal_relative_segment_length = NULL,
            minimal_gain_to_split = NULL,
            model_selection_alpha = NULL,
            number_of_wild_segments = NULL,
            seeded_segments_alpha = NULL,
            seed = NULL,
            random_forest_ntrees = NULL 
        ) {
            self$minimal_relative_segment_length = minimal_relative_segment_length
            self$minimal_gain_to_split = minimal_gain_to_split
            self$model_selection_alpha = model_selection_alpha
            self$number_of_wild_segments = number_of_wild_segments
            self$seeded_segments_alpha = seeded_segments_alpha
            self$seed = seed
            self$random_forest_ntrees = random_forest_ntrees 
        }
    )
)

expect_lists_equal = function(l1, l2) {
    expect(
        length(l1) == length(l2),
        paste0("length mismatch. len(l1)=", length(l1), ", len(l2)=", length(l2))
    )

    if (length(l1) == length(l2) & length(l1) > 0) {  # unbelievable that we have to do this in R.
        for (idx in 1 : length(l1)) {
            expect(
                l1[idx] == l2[idx],
                paste0("value mismatch at idx=", idx, ", l1[idx]=", l1[idx], ", l2[idx]=", l2[idx])
            )
        }
    }
}

get_X = function() {
    matrix(
        c(
            0, 0, 0, 0, 0, 1, 1, 1, 1, 1,
            0, 0, 0, 0, 0, 1, 1, 1, 1, 1,
            0, 0, 0, 1, 1, 1, 1, 1, 1, 1
        ),
        ncol=3
    )
}

get_iris = function() {
    library(datasets)
    data(iris)
    as.matrix(iris[, 1:4])
}

test_that("display", {
    X = get_X()

    result = changeforest(X, "knn", "bs")
    output = capture.output(print(result))

    expected = c(
        "             name best_split max_gain p_value is_significant",
        "1 (0, 10]                  5 8.095522    0.01           TRUE",
        "2  ¦--(0, 5]               3 3.459535    0.01           TRUE",
        "3  ¦    ¦--(0, 3]          1 0.000000    1.00          FALSE",
        "4  ¦    °--(3, 5]         NA       NA      NA          FALSE",
        "5  °--(5, 10]              7 1.383814    1.00          FALSE"
    )

    expect_lists_equal(output, expected)
})

test_that("changeforest_iris", {
    X = get_iris()

    expect_lists_equal(changeforest(X, "knn", "bs")$split_points(), c(50, 100))
    expect_lists_equal(changeforest(X, "change_in_mean", "bs")$split_points(), c(50, 100))
    expect_lists_equal(changeforest(X, "random_forest", "bs")$split_points(), c(50, 100))

    expect_lists_equal(changeforest(X, "knn", "sbs")$split_points(), c(50, 100))
    expect_lists_equal(changeforest(X, "change_in_mean", "sbs")$split_points(), c(50, 100))
    expect_lists_equal(changeforest(X, "random_forest", "sbs")$split_points(), c(50, 100))

    expect_lists_equal(changeforest(X, "knn", "wbs")$split_points(), c(50, 100))
    expect_lists_equal(changeforest(X, "change_in_mean", "wbs")$split_points(), c(50, 100))
    expect_lists_equal(changeforest(X, "random_forest", "wbs")$split_points(), c(50, 100))
})

# Check that all hyperparameters in control are correctly passed to rust.
test_that("control", {
    X = get_X()
    X_iris = get_iris()

    # minimal_relative_segment_length
    expect_lists_equal(changeforest(X, "knn", "bs", Control$new(minimal_relative_segment_length=0.05))$split_points(), c(3, 5))
    expect_lists_equal(changeforest(X, "knn", "bs", Control$new(minimal_relative_segment_length=0.4))$split_points(), c(5))

    # minimal_gain_to_split
    expect_lists_equal(changeforest(X, "change_in_mean", "bs", Control$new(minimal_gain_to_split=0.1))$split_points(), c(3, 5))
    expect_lists_equal(changeforest(X, "change_in_mean", "bs", Control$new(minimal_gain_to_split=0.2))$split_points(), c(5))
    expect_lists_equal(changeforest(X, "change_in_mean", "bs", Control$new(minimal_gain_to_split=1))$split_points(), c())

    # model_selection_alpha
    expect_lists_equal(changeforest(X_iris, "random_forest", "bs", Control$new(model_selection_alpha=0.001))$split_points(),  c())
    expect_lists_equal(changeforest(X_iris, "random_forest", "bs", Control$new(model_selection_alpha=0.05))$split_points(), c(50, 100))

    # seeded_segments_alpha
    expect_equal(length(changeforest(X, "change_in_mean", "bs")$segments), 4)
    expect_equal(length(changeforest(X_iris, "change_in_mean", "sbs", Control$new(minimal_relative_segment_length=0.05, seeded_segments_alpha=1/sqrt(2)))$segments), 44 + 5)
    expect_equal(length(changeforest(X_iris, "change_in_mean", "sbs", Control$new(minimal_relative_segment_length=0.05, seeded_segments_alpha=1/2))$segments), 25 + 5)
    expect_equal(length(changeforest(X, "change_in_mean", "sbs", Control$new(minimal_relative_segment_length=0.05, seeded_segments_alpha=1/2))$segments), 10 + 4)

    # number_of_wild_segments
    expect_equal(length(changeforest(X_iris, "change_in_mean", "wbs", Control$new(number_of_wild_segments=10))$segments), 10 + 5)
    expect_equal(length(changeforest(X_iris, "change_in_mean", "wbs", Control$new(number_of_wild_segments=5))$segments), 5 + 5)

    # seed
    result = changeforest(X_iris, "random_forest", "wbs", Control$new(number_of_wild_segments=10, seed=42))
    expect_equal(result$segments[[1]]$start, 5)
    expect_equal(result$segments[[1]]$max_gain, 17.44774, tolerance=1e-5)
    result = changeforest(X_iris, "random_forest", "wbs", Control$new(number_of_wild_segments=10, seed=12))
    expect_equal(result$segments[[1]]$start, 21)
    expect_equal(result$segments[[1]]$max_gain, 45.43954, tolerance=1e-5)

    # random_forest_ntree
    expect_lists_equal(changeforest(X_iris, "random_forest", "bs", Control$new(random_forest_ntree=1))$split_points(), c(50, 100))
    expect_lists_equal(changeforest(X_iris, "random_forest", "bs", Control$new(random_forest_ntree=100))$split_points(), c(50, 100))
    expect_lists_equal(changeforest(X, "random_forest", "bs", Control$new(random_forest_ntree=1))$split_points(), c())
    expect_lists_equal(changeforest(X, "random_forest", "bs", Control$new(random_forest_ntree=1))$split_points(), c())
    expect_lists_equal(changeforest(X, "random_forest", "bs", Control$new(random_forest_ntree=10))$split_points(), c(5))
})

to_data_frame = function(node, parent_indent="", prefix="") {
    name = paste0(prefix, "(", node$start, ", ", node$stop, "]")

    left = data.frame()
    right = data.frame()

    non_last_prefix = paste0(parent_indent, " ", "\u00A6", "--")  # " ¦--"
    last_prefix = paste0(parent_indent, " ", "\u00B0", "--")  # " °--"

    non_last_indent = paste0(parent_indent, " ", "\u00A6", "   ")
    last_indent = paste0(parent_indent, "    ")

    if (!is.null(node$left)) {
        if (is.null(node$right)) {  # left is only and thus last child
            left = to_data_frame(node$left, last_indent, last_prefix)
        } else {  # left is not last child
            left = to_data_frame(node$left, non_last_indent, non_last_prefix)
        }
    }

    if (!is.null(node$right)) {
        right = to_data_frame(node$right, parent_indent=last_indent, prefix=last_prefix)
    }

    frame = rbind(
        data.frame(
            name=name,
            best_split=node$best_split,
            max_gain=node$max_gain,
            p_value=node$p_value,
            is_significant=node$is_significant
        ),
        left,
        right
    )

    # Strings get printed right-aligned. Add spaces to the right to make then seem
    # left-aligned.
    indent = max(sapply(frame$name, nchar))
    frame$name = apply(
        frame,
        1,
        function(row) paste0(row[1], strrep(" ", indent - nchar(row[1])))
    )

    frame
}

#' Print an object of class `binary_segmentation_result`.
#'
#' @param x An object of class `binary_segmentation_result`.
#' @param ... Not used.
#' @export
print.binary_segmentation_result = function(x, ...) {
    print(to_data_frame(x))
}

BinarySegmentationResult = R6::R6Class(
    "binary_segmentation_result",
    list(
        start = NULL,
        stop = NULL,
        best_split = NULL,
        max_gain = NULL,
        model_selection_result = NULL,
        p_value = NULL,
        is_significant = NULL,
        optimizer_result = NULL,
        segments = NULL,
        left = NULL,
        right = NULL,

        initialize = function(
            start = NULL,
            stop = NULL,
            best_split = NULL,
            max_gain = NULL,
            model_selection_result = NULL,
            p_value = NULL,
            is_significant = NULL,
            optimizer_result = NULL,
            segments = NULL,
            left = NULL,
            right = NULL
        ) {
            self$start = start
            self$stop = stop
            self$best_split = best_split
            self$max_gain = max_gain
            self$model_selection_result = model_selection_result
            self$optimizer_result = optimizer_result
            self$p_value = p_value
            self$is_significant = is_significant
            self$segments = segments
            self$left = left
            self$right = right
        },

        depth = function() {
            max(
                ifelse(is.null(self$left), 0, 1 + self$left$depth()),
                ifelse(is.null(self$right), 0, 1 + self$right$depth())
            )
        },

        split_points = function() {
            split_points = c()

            if (! is.null(self$left)) {
                split_points = append(split_points, self$left$split_points())
            }

            if (!is.null(self$best_split) & self$model_selection_result$is_significant) {
                split_points = append(split_points, c(self$best_split))
            }

            if (! is.null(self$right)) {
                split_points = append(split_points, self$right$split_points())
            }

            split_points
        }
    )
)

to_binary_segmentation_result = function(result) {
    if (!is.null(result$left)) result$left = to_binary_segmentation_result(result$left)
    if (!is.null(result$right)) result$right = to_binary_segmentation_result(result$right)

    result = do.call(BinarySegmentationResult$new, result)
    class(result) = "binary_segmentation_result"

    result
}

#' Find change points in a time series.
#'
#' @param X Numerical matrix with time series.
#' @param method Either 'knn','change_in_mean' of 'random_forest'.
#' @param segmentation Either 'bs', 'sbs' or 'wbs'.
#' @param control Object of class Control containing hyperparameters.
#' @export
changeforest = function(X,  method, segmentation, control=Control$new()) {
    result = changeforest_api(X, method, segmentation, control)
    to_binary_segmentation_result(result)
}

# Generated by extendr: Do not edit by hand
#
# This file was created with the following call:
#   .Call("wrap__make_changeforestr_wrappers", use_symbols = TRUE, package_name = "changeforest")

#' @docType package
#' @usage NULL
#' @useDynLib changeforest, .registration = TRUE
NULL

changeforest_api <- function(X, method, segmentation, control) .Call("wrap__changeforest_api", X, method, segmentation, control, PACKAGE="changeforest")

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/display.R
\name{print.binary_segmentation_result}
\alias{print.binary_segmentation_result}
\title{Print an object of class `binary_segmentation_result`.}
\usage{
\method{print}{binary_segmentation_result}(x, ...)
}
\arguments{
\item{x}{An object of class `binary_segmentation_result`.}

\item{...}{Not used.}
}
\description{
Print an object of class `binary_segmentation_result`.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/changeforest.R
\name{changeforest}
\alias{changeforest}
\title{Find change points in a time series.}
\usage{
changeforest(X, method, segmentation, control = Control$new())
}
\arguments{
\item{X}{Numerical matrix with time series.}

\item{method}{Either 'knn','change_in_mean' of 'random_forest'.}

\item{segmentation}{Either 'bs', 'sbs' or 'wbs'.}

\item{control}{Object of class Control containing hyperparameters.}
}
\description{
Find change points in a time series.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/control.R
\name{Control}
\alias{Control}
\title{Storage container for hyperparameters.}
\description{
See rust documentation of changeforest::control::Control for more details.
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-new}{\code{Control$new()}}
\item \href{#method-clone}{\code{Control$clone()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-new"></a>}}
\if{latex}{\out{\hypertarget{method-new}{}}}
\subsection{Method \code{new()}}{
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Control$new(
  minimal_relative_segment_length = NULL,
  minimal_gain_to_split = NULL,
  model_selection_alpha = NULL,
  number_of_wild_segments = NULL,
  seeded_segments_alpha = NULL,
  seed = NULL,
  random_forest_ntrees = NULL
)}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-clone"></a>}}
\if{latex}{\out{\hypertarget{method-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Control$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}
